# -*- coding: utf-8 -*-
"""
Created on March 2016

@author: Andrés Cencerrado
"""

#Numeric DT implementation 

####Activity 3: goodness function definition
def goodness(classes,attr_values):
    best_cutoff = (0,0,'','') 
    #(cutoff value,proportion of correctly classified instances,majority class up to cutoff point,majority class from cutoff point)
    resultat=[]
    # CALCUL DELS PUNTS DE TALL. PRIMER ELIMINEM ELS VALORS REPETITS. ELS PUNTS DE TALL ES TROBEN A LA MEITAT EXACTE
    # ENTRE DOS VALORS DE UN ATRIBUT

    llistaatributsordered=list(set(sorted(attr_values)))
    classeatributs=list(set(classes))
    puntsdetall=[]
    for i in range(len(llistaatributsordered)-1):
        puntsdetall.append((llistaatributsordered[i]+llistaatributsordered[i+1])/2.)
    # CALCULEM LA PROPORCIO DE CLASSE DE CADA PUNT DE TALL TAL COM SE EXPLICA A LA TEORIA.
    for punt in puntsdetall:
        comptadorsmenors=len(classeatributs)*[0]
        comptadorsmajors=len(classeatributs)*[0]
        for element in range(len(attr_values)):
            if attr_values[element]<punt:
                for k in range(len(classeatributs)):
                    if classes[element]==classeatributs[k]:
                        comptadorsmenors[k]=comptadorsmenors[k] + 1
            else:
                for k in range(len(classeatributs)):
                    if classes[element]==classeatributs[k]:
                        comptadorsmajors[k]=comptadorsmajors[k] + 1
        maxmenor=max(comptadorsmenors)
        maxmajor=max(comptadorsmajors)
        proporcio=(maxmenor+maxmajor)/float(len(attr_values))
        resultat.append((punt,proporcio,classeatributs[comptadorsmenors.index(maxmenor)],classeatributs[comptadorsmajors.index(maxmajor)]))
    resultatfinal=sorted(resultat, key=lambda x:x[1],reverse=True)
    # RETORNEM LA MILLOR TUPLA QUE RESULTA A SER EL PRIMER ELEMENT DESPRES DE ORDENAR ELS ELEMENTS PEL SEGON INDEX.
    best_cutoff=resultatfinal[0]    
    return best_cutoff




#training_set = [{attr1: val1, attr2: val2, ... , 'class':class_id}]
#attribute named 'class' is mandatory 
def generateDT(training_set, max_depth=5, min_accuracy=0.9):
    
    print("\nGenerating Decision Tree for a training set of " + str(len(training_set)) + " instances...")    
    
    decision_tree = []
    training_subset1 = []
    training_subset2 = []
    classes = [instance['class'] for instance in training_set]

    if classes.count(classes[0]) == len(classes): #if all instances in training set have same 'class' attribute
        return ("class",classes[0])
 
    attributes = {attribute:[instance[attribute] for instance in training_set] for attribute in training_set[0] if attribute != 'class'}

    print("Obtaining goodness values... Remaining levels: "+str(max_depth))     
    best_attribute = max([(attr,) + goodness(classes,attributes[attr]) for attr in attributes.keys()], key = lambda x: x[2]) #best attribute according to its goodness
       
    
    if (best_attribute[2] >= min_accuracy) | (max_depth == 1): #minimum accuracy or max_depth reached
        return [(best_attribute[0],best_attribute[1],("class",best_attribute[3]),("class",best_attribute[4]))]        
        
    for i in range(len(training_set)):        
        if training_set[i][best_attribute[0]] <= best_attribute[1]:
            training_subset1.append(training_set[i])
        else:
            training_subset2.append(training_set[i])
    
    decision_tree.append((best_attribute[0],best_attribute[1],generateDT(training_subset1,max_depth=max_depth-1,min_accuracy=min_accuracy),generateDT(training_subset2,max_depth=max_depth-1,min_accuracy=min_accuracy)))

    return decision_tree
    
    
def classify(instance, dectree):

    if dectree[0] == 'class':
        return dectree[1]

    if instance[dectree[0][0]] < dectree[0][1]:
        return classify(instance, dectree[0][2])
    else:
        return classify(instance, dectree[0][3])
        


def runTest(instance_list, dectree):
    
    hits = 0    
    
    for i in instance_list:
        real_class = i['class']
        pred_class = classify(i,dectree)
        
        if real_class == pred_class:
            hits += 1
    
    print('\n-------------------\nAccuracy: ' + str(100*hits/len(instance_list)) + '%\n-------------------')
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    